<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/ads/googleads/v9/services/keyword_plan_service.proto

namespace Google\Ads\GoogleAds\V9\Services;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A keyword historical metrics.
 *
 * Generated from protobuf message <code>google.ads.googleads.v9.services.KeywordPlanKeywordHistoricalMetrics</code>
 */
class KeywordPlanKeywordHistoricalMetrics extends \Google\Protobuf\Internal\Message
{
    /**
     * The text of the query associated with one or more ad_group_keywords in the
     * plan.
     * Note that we de-dupe your keywords list, eliminating close variants before
     * returning the plan's keywords as text. For example, if your plan originally
     * contained the keywords 'car' and 'cars', the returned search query will
     * only contain 'cars'.
     * Starting V5, the list of de-duped queries will be included in
     * close_variants field.
     *
     * Generated from protobuf field <code>optional string search_query = 4;</code>
     */
    protected $search_query = null;
    /**
     * The list of close variant queries for search_query whose search results
     * are combined into the search_query.
     *
     * Generated from protobuf field <code>repeated string close_variants = 3;</code>
     */
    private $close_variants;
    /**
     * The historical metrics for the query associated with one or more
     * ad_group_keywords in the plan.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.common.KeywordPlanHistoricalMetrics keyword_metrics = 2;</code>
     */
    protected $keyword_metrics = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $search_query
     *           The text of the query associated with one or more ad_group_keywords in the
     *           plan.
     *           Note that we de-dupe your keywords list, eliminating close variants before
     *           returning the plan's keywords as text. For example, if your plan originally
     *           contained the keywords 'car' and 'cars', the returned search query will
     *           only contain 'cars'.
     *           Starting V5, the list of de-duped queries will be included in
     *           close_variants field.
     *     @type string[]|\Google\Protobuf\Internal\RepeatedField $close_variants
     *           The list of close variant queries for search_query whose search results
     *           are combined into the search_query.
     *     @type \Google\Ads\GoogleAds\V9\Common\KeywordPlanHistoricalMetrics $keyword_metrics
     *           The historical metrics for the query associated with one or more
     *           ad_group_keywords in the plan.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Ads\GoogleAds\V9\Services\KeywordPlanService::initOnce();
        parent::__construct($data);
    }

    /**
     * The text of the query associated with one or more ad_group_keywords in the
     * plan.
     * Note that we de-dupe your keywords list, eliminating close variants before
     * returning the plan's keywords as text. For example, if your plan originally
     * contained the keywords 'car' and 'cars', the returned search query will
     * only contain 'cars'.
     * Starting V5, the list of de-duped queries will be included in
     * close_variants field.
     *
     * Generated from protobuf field <code>optional string search_query = 4;</code>
     * @return string
     */
    public function getSearchQuery()
    {
        return isset($this->search_query) ? $this->search_query : '';
    }

    public function hasSearchQuery()
    {
        return isset($this->search_query);
    }

    public function clearSearchQuery()
    {
        unset($this->search_query);
    }

    /**
     * The text of the query associated with one or more ad_group_keywords in the
     * plan.
     * Note that we de-dupe your keywords list, eliminating close variants before
     * returning the plan's keywords as text. For example, if your plan originally
     * contained the keywords 'car' and 'cars', the returned search query will
     * only contain 'cars'.
     * Starting V5, the list of de-duped queries will be included in
     * close_variants field.
     *
     * Generated from protobuf field <code>optional string search_query = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setSearchQuery($var)
    {
        GPBUtil::checkString($var, True);
        $this->search_query = $var;

        return $this;
    }

    /**
     * The list of close variant queries for search_query whose search results
     * are combined into the search_query.
     *
     * Generated from protobuf field <code>repeated string close_variants = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getCloseVariants()
    {
        return $this->close_variants;
    }

    /**
     * The list of close variant queries for search_query whose search results
     * are combined into the search_query.
     *
     * Generated from protobuf field <code>repeated string close_variants = 3;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setCloseVariants($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->close_variants = $arr;

        return $this;
    }

    /**
     * The historical metrics for the query associated with one or more
     * ad_group_keywords in the plan.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.common.KeywordPlanHistoricalMetrics keyword_metrics = 2;</code>
     * @return \Google\Ads\GoogleAds\V9\Common\KeywordPlanHistoricalMetrics|null
     */
    public function getKeywordMetrics()
    {
        return $this->keyword_metrics;
    }

    public function hasKeywordMetrics()
    {
        return isset($this->keyword_metrics);
    }

    public function clearKeywordMetrics()
    {
        unset($this->keyword_metrics);
    }

    /**
     * The historical metrics for the query associated with one or more
     * ad_group_keywords in the plan.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.common.KeywordPlanHistoricalMetrics keyword_metrics = 2;</code>
     * @param \Google\Ads\GoogleAds\V9\Common\KeywordPlanHistoricalMetrics $var
     * @return $this
     */
    public function setKeywordMetrics($var)
    {
        GPBUtil::checkMessage($var, \Google\Ads\GoogleAds\V9\Common\KeywordPlanHistoricalMetrics::class);
        $this->keyword_metrics = $var;

        return $this;
    }

}

